package view;

import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JFrame;

import model.Alarm;
import model.Observer;

@SuppressWarnings("serial")
public abstract class AlarmView extends JFrame implements Observer, WindowListener {
	protected Alarm alarm;
	public AlarmView(Alarm a, AlarmListFrame frame) {
		alarm = a;
    	setTitle(alarm.getName());
    	setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        addWindowListener(this);
        setLocationRelativeTo(frame);
	}
	protected void changeName() {
    	setTitle(alarm.getName());
	}
	protected abstract void changeTime();
	protected abstract void changeEnabled();
	protected String textForHalfADay() {
		return alarm.getTime().isMorningTime() ? "matin" : "aprs-midi";
	}
	//en tant que WindowListener
    public void windowActivated(WindowEvent e) { }
    public void windowDeactivated(WindowEvent e) { }
    public void windowClosing(WindowEvent e) {
    	alarm.removeObserver(this);
    }
    public void windowClosed(WindowEvent e) { }
    public void windowIconified(WindowEvent e) { }
    public void windowDeiconified(WindowEvent e) { }
    public void windowOpened(WindowEvent e) { }
}
